﻿using Ant_Colony_Optimalization.Graph;
using Ant_Colony_Optimalization.Graphic.Object;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Ant_Colony_Optimalization.Graphic.Render
{
    public class CEdgeRender
    {
        private Panel panel;
        private Pen pen;
        private Graphics g;
        public CEdgeRender(Panel panel)
        {
            this.panel = panel;
        }

        public void DrawAll(IEnumerable edgeList)
        {
            try
            {
                this.g = this.panel.CreateGraphics();
                this.pen = new Pen(Color.LightGray);

                foreach (CEdge line2 in edgeList)
                {
                    CEdgeLine line = line2.ToCEdgeLine();
                    g.DrawLine(pen, line.Point1.Point, line.Point2.Point);
                }
                pen.Dispose();
                g.Dispose();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public void DrawRed(LinkedList<CEdgeLine> edgeList)
        {
            try
            {
            int counter = 0;
            this.g = this.panel.CreateGraphics();
            this.pen = new Pen(Color.Red);
            pen.Width = 10;

           
            SolidBrush drawBrush = new SolidBrush(System.Drawing.Color.Red);
            StringFormat drawFormat = new System.Drawing.StringFormat();

            foreach (CEdgeLine line in edgeList)
            {
                double[] array1 = { line.Point1.Point.X, line.Point2.Point.X };
                double averageX = array1.Average();

                double[] array2 = { line.Point1.Point.Y, line.Point2.Point.Y };
                double averageY = array2.Average();

                g.DrawLine(pen, line.Point1.Point, line.Point2.Point);
                counter++;
            }
            pen.Dispose();
            g.Dispose();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public void DrawGreen(LinkedList<CEdgeLine> edgeList)
        {            try
            {
            this.g = this.panel.CreateGraphics();
            this.pen = new Pen(Color.Green);
            this.pen.Width = 2;
            foreach (CEdgeLine line in edgeList)
            {
                g.DrawLine(pen, line.Point1.Point, line.Point2.Point);
            }
            pen.Dispose();
            g.Dispose();
 }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        public void DrawPink(LinkedList<CEdgeLine> edgeList)
        {
            this.g = this.panel.CreateGraphics();
            this.pen = new Pen(Color.Orange);
            this.pen.Width = 10;
            foreach (CEdgeLine line in edgeList)
            {
                g.DrawLine(pen, line.Point1.Point, line.Point2.Point);
            }
            pen.Dispose();
            g.Dispose();
        }

        public void DrawBrown(LinkedList<CEdgeLine> edgeList)
        {
            this.g = this.panel.CreateGraphics();
            this.pen = new Pen(Color.Brown);
            this.pen.Width = 7;
            foreach (CEdgeLine line in edgeList)
            {
                g.DrawLine(pen, line.Point1.Point, line.Point2.Point);
            }
            pen.Dispose();
            g.Dispose();
        }


    }

}
