﻿using Ant_Colony_Optimalization.Graph;
using Ant_Colony_Optimalization.Graphic;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Ant_Colony_Optimalization.Other
{
    public class CNodeAnalyzator
    {
        private double alpha;
        private double beta;

        private DataGridView datagridView;
        private CNode node;
        public CNodeAnalyzator(DataGridView datagridView, CNode node, double alpha, double beta)
        {
            this.datagridView = datagridView;
            this.datagridView.Rows.Clear();
            this.node = node;
            this.alpha = alpha;
            this.beta = beta;
        }

        public CNodeAnalyzator()
        {

        }

        public double GetShortestEdgeLength()
        {
            double shortes = double.MaxValue;
            foreach (CEdge edge in this.node.EdgeArray)
            {
                if (edge.Distance < shortes)
                {
                    shortes = edge.Distance;
                }
            }
            return shortes;
        }

        public double GetSecontShortestEdgeLength()
        {
            double shortesLength = this.GetShortestEdgeLength();
            double secondShortes = double.MaxValue;
            foreach (CEdge edge in this.node.EdgeArray)
            {
                if (edge.Distance > shortesLength && edge.Distance < secondShortes)
                {
                    secondShortes = edge.Distance;
                }
            }
            return secondShortes;
        }

        public void ShowEdgesInfo()
        {

            double sum = 0;
            for (int i = 0; i < this.node.EdgeArray.Count(); i++)
            {
                sum += this.CalculateTauete(this.node.EdgeArray[i].Pheromone, this.node.EdgeArray[i].Distance);
            }
            for (int i = 0; i < this.node.EdgeArray.Count(); i++)
            {
                double teuta = this.CalculateTauete(this.node.EdgeArray[i].Pheromone, this.node.EdgeArray[i].Distance);
                double probability = (teuta / sum);
                this.datagridView.Rows.Add(i, this.node.EdgeArray[i].Pheromone, this.node.EdgeArray[i].Distance, (Math.Round(probability, 3, MidpointRounding.AwayFromZero)).ToString());

            }
        }

        public double CalculateTauete(double pheromone, double distance)
        {
            double tauete = System.Math.Pow(pheromone, alpha) * System.Math.Pow((1 / distance), beta);
            return tauete;
        }

        public CNodePhoremoneStrenge GetPheremoneStrenge(CNode node)
        {
            double strenge = 0;
            foreach (CEdge edge in node.EdgeArray)
            {
                // strenge += edge.Pheromone;
                if (edge.Pheromone > strenge)
                {
                    strenge = edge.Pheromone;
                }
            }
            //return new CNodePhoremoneStrenge(this.node.Point, (strenge/this.node.EdgeArray.Count()));
            return new CNodePhoremoneStrenge(node.Point, (strenge));
        }
    }
}
