﻿using Ant_Colony_Optimalization.Ant.PheromoneActualization;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Ant_Colony_Optimalization.Other
{
    public class CSettingsHolder
    {
        private double alpha;
        private double beta;
        private int antCount;
        private int bestCount;
        private double betterThan;
        private IPheromoneIncrease pheromonIncreaseFunction;
        private IPheromoneDecrease pheromonDecreaseFunction;
        private int pathRowCount;
        private int pathColumnCount;
        private int startNodeId;
        private int finishNodeId;

        public double Aplha
        {
            get { return alpha; }
        }

        public double Beta
        {
            get { return beta; }
        }

        public double AntCount
        {
            get { return antCount; }
        }

        public double BestCount
        {
            get { return bestCount; }
        }

        public double BetterThan
        {
            get { return betterThan; }
        }

        public int PathRowCount
        {
            get { return this.pathRowCount; }
        }

        public int PathColumnCount
        {
            get { return this.pathColumnCount; }
        }

        public IPheromoneIncrease PheromonIncreaseFunction
        {
            get { return pheromonIncreaseFunction; }
        }


        public IPheromoneDecrease PheromonDecreaseFunction
        {
            get { return pheromonDecreaseFunction; }
        }

        public int StartNodeId
        {
            get { return this.startNodeId; }
        }

        public int FinishNodeId
        {
            get { return this.finishNodeId; }
        }

        public CSettingsHolder(double alpha, double beta, int antCount, int bestCount, double betterThan,IPheromoneIncrease pheromoneIncreaseFunction, IPheromoneDecrease pheromoneDecreaseFunction)
        {
            this.alpha = alpha;
            this.beta = beta;
            this.antCount = antCount;
            this.bestCount = bestCount;
            this.betterThan = betterThan;
            this.pheromonIncreaseFunction = pheromoneIncreaseFunction;
            this.pheromonDecreaseFunction = pheromoneDecreaseFunction;
            this.pathRowCount = 0;
            this.pathColumnCount = 0;
        }

        public CSettingsHolder(double alpha, double beta, int antCount, int bestCount, double betterThan, IPheromoneIncrease pheromoneIncreaseFunction, IPheromoneDecrease pheromoneDecreaseFunction, int startNodeId, int finishNodeId)
        {
            this.alpha = alpha;
            this.beta = beta;
            this.antCount = antCount;
            this.bestCount = bestCount;
            this.betterThan = betterThan;
            this.pheromonIncreaseFunction = pheromoneIncreaseFunction;
            this.pheromonDecreaseFunction = pheromoneDecreaseFunction;
            this.pathRowCount = 0;
            this.pathColumnCount = 0;
            this.startNodeId = startNodeId;
            this.finishNodeId = finishNodeId;
        }
    }
}
